plugins {
    `java-library`
}

repositories {
    mavenCentral()
    maven {
        setUrl("https://gitlab.com/api/v4/projects/35745143/packages/maven")
    }
}

dependencies {
    api("io.gitlab.jfronny:commons:${rootProject.extra["jfCommonsVersion"]}")
    api("io.gitlab.jfronny:commons-gson:${rootProject.extra["jfCommonsVersion"]}")
    implementation("io.gitlab.jfronny:commons-slf4j:${rootProject.extra["jfCommonsVersion"]}")
    implementation("ch.qos.logback:logback-classic:${rootProject.extra["logbackVersion"]}")
}

tasks.processResources {
    filesMatching("version.json") {
        expand(
            "version" to project.version,
            "flavor" to rootProject.extra["flavorProp"],
            "isPublic" to rootProject.extra["isPublic"],
            "isRelease" to rootProject.extra["isRelease"],
            "jvm" to project.java.targetCompatibility
        )
    }
}