package io.gitlab.jfronny.inceptum.util;

import io.gitlab.jfronny.inceptum.model.inceptum.Config;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.HashMap;

public class ConfigHolder {
    public static Config CONFIG;

    public static void load() throws IOException {
        if (!Files.exists(MetaHolder.CONFIG_PATH.getParent())) Files.createDirectories(MetaHolder.CONFIG_PATH.getParent());
        if (!Files.exists(MetaHolder.CONFIG_PATH)) {
            Path gLaunch2 = MetaHolder.BASE_PATH.resolve("glaunch2.json");
            if (Files.exists(gLaunch2)) {
                Files.move(gLaunch2, MetaHolder.CONFIG_PATH);
            }
            else {
                Utils.writeObject(MetaHolder.CONFIG_PATH, new Config());
            }
        }
        CONFIG = Utils.loadObject(MetaHolder.CONFIG_PATH, Config.class);
        boolean changed = false;
        if (CONFIG.git == null) {
            CONFIG.git = new Config.GitConfig();
            changed = true;
        }
        if (CONFIG.git.instanceAuths == null) {
            CONFIG.git.instanceAuths = new HashMap<>();
            changed = true;
        }
        if (changed) saveConfig();
    }

    public static void saveConfig() {
        try {
            Utils.writeObject(MetaHolder.CONFIG_PATH, CONFIG);
        } catch (IOException e) {
            Utils.LOGGER.error("Could not save config", e);
        }
    }
}
