package io.gitlab.jfronny.inceptum.util.cache;

import io.gitlab.jfronny.commons.throwable.ThrowingSupplier;

import java.util.concurrent.ConcurrentHashMap;

public class MemoryCache<TKey, TValue> {
    private final ConcurrentHashMap<TKey, TValue> container = new ConcurrentHashMap<>();

    public void remove(TKey key) {
        container.remove(key);
    }

    public void clear() {
        container.clear();
    }

    public void write() {
    }

    public <TEx extends Throwable> TValue get(TKey key, ThrowingSupplier<TValue, TEx> builder) throws TEx {
        if (!container.containsKey(key)) container.put(key, builder.get());
        return container.get(key);
    }
}
