package io.gitlab.jfronny.inceptum.frontend.cli;

import io.gitlab.jfronny.inceptum.frontend.cli.commands.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Commands {
    private static final GuiCommand GUI_COMMAND = new GuiCommand();
    public static final Command COMMANDS_ROOT = new Command("Root command", "<command>", List.of(), List.of(
            new HelpCommand(),
            GUI_COMMAND,
            new LaunchCommand(),
            new ListCommand(),
            new ModCommand(),
            new GitCommand(),
            new ExportCommand(),
            new UpdateCheckCommand(),
            new JvmStateCommand(),
            new BatchCommand(),
            new WrapperCommand()
    )) {
        @Override
        protected void invoke(CommandArgs args) {
            throw new RuntimeException("Could not find command: " + args.get(0));
        }

        @Override
        public CommandResolution resolve(CommandArgs args) {
            if (args.length == 0) return new CommandResolution(GUI_COMMAND, args, new ArrayList<>());
            return super.resolve(args);
        }
    };

    public static CommandResolution resolve(String[] args, boolean wrapped) {
        return COMMANDS_ROOT.resolve(new CommandArgs(Arrays.asList(args), wrapped));
    }
}
