package io.gitlab.jfronny.inceptum.model.inceptum;

import io.gitlab.jfronny.commons.serialize.gson.api.*;

import java.util.*;

public class InstanceMeta {
    @Ignore
    public static final String floaderPrefix = "fabric-loader-";
    public String version;
    public String java;
    public Long minMem;
    public Long maxMem;
    public Arguments arguments;

    public boolean isFabric() {
        return version.startsWith(floaderPrefix);
    }

    public String getMinecraftVersion() {
        return getMinecraftVersion(version);
    }

    public static String getMinecraftVersion(String id) {
        return id.startsWith(floaderPrefix) ? id.substring(id.lastIndexOf('-') + 1) : id;
    }

    public String getLoaderVersion() {
        return isFabric() ? version.substring(floaderPrefix.length()).split("-")[0] : "";
    }

    public static class Arguments {
        public List<String> jvm;
        public List<String> client;
        public List<String> server;

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            Arguments arguments = (Arguments) o;
            return Objects.equals(jvm, arguments.jvm)
                    && Objects.equals(client, arguments.client)
                    && Objects.equals(server, arguments.server);
        }

        @Override
        public int hashCode() {
            return Objects.hash(jvm, client, server);
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        InstanceMeta that = (InstanceMeta) o;
        return Objects.equals(version, that.version)
                && Objects.equals(java, that.java)
                && Objects.equals(minMem, that.minMem)
                && Objects.equals(maxMem, that.maxMem)
                && Objects.equals(arguments, that.arguments);
    }

    @Override
    public int hashCode() {
        return Objects.hash(version, java, minMem, maxMem, arguments);
    }
}
