package io.gitlab.jfronny.inceptum.util;

import io.gitlab.jfronny.inceptum.util.mds.IWModDescription;
import io.gitlab.jfronny.inceptum.util.mds.ModsDirScanner;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

public class ModManager {
    public static void delete(IWModDescription md, Path modsDirectory, ModsDirScanner mds) throws IOException {
        Utils.deleteRecursive(md.path());
        if (md.imod().isPresent() && Files.exists(md.imod().get())) Files.delete(md.imod().get());
        if (md.mod().isPresent()) {
            for (String dependency : md.mod().get().dependencies) {
                Path dep = modsDirectory.resolve(dependency);
                IWModDescription dmd = mds.get(dep);
                if (dmd.mod().isPresent()) {
                    dmd.mod().get().dependencies.remove(md.path().getFileName().toString());
                    if (dmd.mod().get().dependencies.isEmpty()) delete(dmd, modsDirectory, mds);
                    else if (dmd.imod().isPresent())
                        Utils.writeObject(dmd.imod().get(), dmd.mod().get());
                }
            }
        }
    }
}
