package io.gitlab.jfronny.inceptum.util.install.steps;

import io.gitlab.jfronny.inceptum.model.inceptum.InstanceMeta;
import io.gitlab.jfronny.inceptum.util.MetaHolder;
import io.gitlab.jfronny.inceptum.util.Utils;
import io.gitlab.jfronny.inceptum.util.install.SetupStepInfo;
import io.gitlab.jfronny.inceptum.util.install.Step;
import io.gitlab.jfronny.inceptum.util.mds.ModsDirScanner;

import java.io.IOException;
import java.nio.file.Path;
import java.util.concurrent.atomic.AtomicBoolean;

public class RunMdsStep implements Step {
    @Override
    public void execute(SetupStepInfo info, AtomicBoolean stopThread) throws IOException {
        info.setState("Running MDS");
        Path instance = MetaHolder.INSTANCE_DIR.resolve(info.name());
        ModsDirScanner.get(instance.resolve("mods"), Utils.loadObject(instance.resolve("instance.json"), InstanceMeta.class))
                .runOnce((path, iwModDescription) -> {
                    info.setState("Scanned " + path);
                });
    }
}
