package io.gitlab.jfronny.inceptum.util.mds;

import io.gitlab.jfronny.inceptum.model.inceptum.InstanceMeta;

import java.io.Closeable;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Set;
import java.util.function.BiConsumer;

public interface ModsDirScanner extends Closeable {
    static ModsDirScanner get(Path modsDir, InstanceMeta instance) throws IOException {
        if (Files.exists(modsDir)) return ModsDirScannerImpl.get(modsDir, instance);
        return new NoopMds(instance.getMinecraftVersion());
    }

    static void closeAll() {
        ModsDirScannerImpl.closeAll();
    }

    boolean isComplete();
    void start();
    String getGameVersion();
    Set<IWModDescription> getMods() throws IOException;
    IWModDescription get(Path path);
    void invalidate(Path path);
    boolean hasScanned(Path path);
    void runOnce(BiConsumer<Path, IWModDescription> discovered);
}
